//
//  ViewController.m
//  ObjCSample
//
//  Created by Lopez Valenciano, Miguel on 2/24/16.
//  Copyright © 2016 Akamai. All rights reserved.
//

#import "ViewController.h"

@interface ViewController () {
    AmpPlayer *_ampPlayer;
    AmpMediaAnalyticsManager *_maManager;
    AmpIMAManager *_imaManager;
}

@end

NSString *const url = @"http://multiplatform-f.akamaihd.net/i/multi/will/bunny/big_buck_bunny_,640x360_400,640x360_700,640x360_1000,950x540_1500,.f4v.csmil/master.m3u8";
NSString *const urlOcto = @"octoshape://streams.octoshape.net/demo/live/nascar/abr";
NSString *const adsPreMidPostRolls = @"https://pubads.g.doubleclick.net/gampad/ads?sz=640x480&iu=/124319096/external/ad_rule_samples&ciu_szs=300x250&ad_rule=1&impl=s&gdfp_req=1&env=vp&output=vmap&unviewed_position_start=1&cust_params=deployment%3Ddevsite%26sample_ar%3Dpremidpost&cmsid=496&vid=short_onecue&correlator=";

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    
    _ampPlayer = [[AmpPlayer alloc] initWithParentView: self.view];
    
    [_ampPlayer setLicense:@"AwEbV57kyzoNBBW73pBrR8fbbNDmh5+bpTVkiFfmxcGzvbV3fFKkVQJGmWAcGQJ1w7rXQgdNU56uTw1x54oSMmP2UDbxllU2SGI0CbM0D2iBwi9xXY/X8hlhLDPvAAtA2qu1zmvAPCsSSw9r47/qgRV4b33VlXYQoSgyxZwtpYmNj/wfMSdBO/4nPszHZea5qYXAxGS0jjDY0k+oFYDGOxKRXwNVCEPDZKYSdukVzEvnTw=="];
//    _ampPlayerManager = [[AmpPlayerManager alloc] initWithAmpPlayer:_ampPlayer parentView:self.view playerFrame:self.view.frame];
    _imaManager = [[AmpIMAManager alloc] initWithAmpPlayer:_ampPlayer videoView:self.view coder:nil];
    
    [self setupAnalytics];
    [_ampPlayer setAutoplay:YES];
    
    [_ampPlayer registerObserver:self];
    [_ampPlayer handleUrl:url];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(void)setupAnalytics {
    NSString *analyticsUrl = @"https://ma1019-r.analytics.edgekey.net/config/beacon-8566.xml";
    
    NSDictionary *customData = @{
                                 @"title": @"AKaMTitle",
                                 @"category": @"AKamCategory",
                                 @"playerId": @"AKAM AVPlayer playerId",
                                 @"device": @"AKAM AVPlayer device",
                                 @"show": @"AKAM AVPlayer$show"
                                 };
    _maManager = [[AmpMediaAnalyticsManager alloc] initWithAmpPlayer:_ampPlayer configurationUrl:analyticsUrl dimensions:customData viewerId:@"AMP iOS"];
    
}

// MARK: PlayerEventObserver
-(void)onAmpBufferingStateChanged:(AmpPlayer *)ampPlayer {
    if (ampPlayer.bufferingState == BufferingStateReady) {
//        [ampPlayer play];
        [_imaManager requestAdsWithAdsUrl:adsPreMidPostRolls companionView:nil];
    }
}


@end
